#import "REFMethodChannel.h"

NS_ASSUME_NONNULL_BEGIN

@class REFClassTemplate;

@protocol REFClassTemplate <NSObject>
- (NSNumber *_Nullable)fieldTemplate;
- (NSObject *_Nullable)methodTemplate:(NSString *_Nullable)parameterTemplate;
@end

@interface REFClassTemplateCreationArgs : NSObject
@property NSNumber *_Nullable fieldTemplate;
@end

@interface REFClassTemplateChannel : REFTypeChannel
- (instancetype)initWithManager:(REFTypeChannelManager *)manager;
- (void)invoke_staticMethodTemplate:(NSString *_Nullable)parameterTemplate
                         completion:(void (^)(id _Nullable, NSError *_Nullable))completion;
- (void)invoke_methodTemplate:(NSObject<REFClassTemplate> *)instance
            parameterTemplate:(NSString *_Nullable)parameterTemplate
                   completion:(void (^)(id _Nullable, NSError *_Nullable))completion;
@end

@interface REFClassTemplateHandler : NSObject<REFTypeChannelHandler>
- (NSObject<REFClassTemplate> *)onCreate:(REFTypeChannelManager *)manager
                                             args:(REFClassTemplateCreationArgs *)args;
- (NSObject *_Nullable)on_staticMethodTemplate:(REFTypeChannelManager *)manager
                             parameterTemplate:(NSString *_Nullable)parameterTemplate;
@end

NS_ASSUME_NONNULL_END
